;----------------------------------------------------------------------------;
; INIT_53.ASM                                                                ;
;                                                                            ;
; (c) Copyright 1992, Zonn Moore.  All rights reserved.                      ;
;----------------------------------------------------------------------------;
		Ideal

		include	"bcmacros.inc"

		CodeSeg	MISCC

;----------------------------------------------------------------------------;
; void init_8253()							     ;
;									     ;
; Initialize 8253 to mode 2 instead of mode 3.  This should only be	     ;
; called once, and can cause a one time error, in the real-time clock, of    ;
; no more than 55ms.  Except for the above single time error, this routine   ;
; does not effect the real-time clock.					     ;
;									     ;
; Overview:								     ;
;									     ;
; The 8253 is supplied by with a 14.31818mhz / 12 = 1193181.667hz clock.     ;
;									     ;
; The BIOS uses mode 3 with a count of 0000h, when programming the the 8253  ;
; which results in a square wave with a count of 65536.  This causes the     ;
; 8253 to decrement by 2 each clock time, which is how the count is really   ;
; the cylce time of the full square wave.				     ;
;									     ;
; This routine re-initializes the 8253 to mode 2 with a count of 0000h.	     ;
; This causes the 8253 to decrement by 1 each clock time, with a single	     ;
; pulse at the zero count to signal the 8259.  The time between pulses is    ;
; the same as the time of the square wave, so nothing is changed in	     ;
; real-time clock accuracy.						     ;
;									     ;
; Since the 8253 is re-initialized, up to 55ms of time can be lost.	     ;
;----------------------------------------------------------------------------;
public		_init_8253
proc		_init_8253	c

		mov	al,034h		; set to mode 2
		out	043h,al
		IOWAIT
		sub	al,al		; zero count
		out	040h,al		; set counter
		IOWAIT
		out	040h,al
		ret
		endp

;----------------------------------------------------------------------------;
; void restore_8253()							     ;
;									     ;
; Restores 8253 timer to MODE 3 (a few programs use this timer and expect it ;
; to be setup in MODE 3.)						     ;
;									     ;
; Since the 8253 is re-initialized, up to 55ms of time can be lost.	     ;
;----------------------------------------------------------------------------;
public		_restore_8253
proc		_restore_8253	c

		mov	al,36h		; set to mode 3
		out	043h,al
		IOWAIT
		sub	al,al		; zero count
		out	040h,al		; set counter
		IOWAIT
		out	040h,al
		ret
		endp

		end
